<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from form-processor/xml/schema/CRM/FormProcessor/FormProcessorDefaultDataInput.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:f17d098d588a2a0a57f87259d6866fd7)
 */
use CRM_FormProcessor_ExtensionUtil as E;

/**
 * Database access object for the FormProcessorDefaultDataInput entity.
 */
class CRM_FormProcessor_DAO_FormProcessorDefaultDataInput extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_form_processor_default_data_input';

  /**
   * Field to show when displaying a record.
   *
   * @var string
   */
  public static $_labelField = 'title';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * Unique FormProcessorInput ID
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * FK to Form Processor
   *
   * @var int|string
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $form_processor_id;

  /**
   * @var int|string
   *   (SQL type: int)
   *   Note that values will be retrieved from the database as a string.
   */
  public $weight;

  /**
   * @var bool|string
   *   (SQL type: tinyint)
   *   Note that values will be retrieved from the database as a string.
   */
  public $include_formatted_params;

  /**
   * @var string
   *   (SQL type: varchar(128))
   *   Note that values will be retrieved from the database as a string.
   */
  public $title;

  /**
   * @var string
   *   (SQL type: varchar(80))
   *   Note that values will be retrieved from the database as a string.
   */
  public $name;

  /**
   * @var string
   *   (SQL type: varchar(80))
   *   Note that values will be retrieved from the database as a string.
   */
  public $type;

  /**
   * @var bool|string
   *   (SQL type: tinyint)
   *   Note that values will be retrieved from the database as a string.
   */
  public $is_required;

  /**
   * @var string
   *   (SQL type: varchar(256))
   *   Note that values will be retrieved from the database as a string.
   */
  public $default_value;

  /**
   * @var string
   *   (SQL type: longtext)
   *   Note that values will be retrieved from the database as a string.
   */
  public $configuration;

  /**
   * @var string
   *   (SQL type: longtext)
   *   Note that values will be retrieved from the database as a string.
   */
  public $parameter_mapping;

  /**
   * @var string
   *   (SQL type: longtext)
   *   Note that values will be retrieved from the database as a string.
   */
  public $default_data_parameter_mapping;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_form_processor_default_data_input';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('Form Processor Default Data Inputs') : E::ts('Form Processor Default Data Input');
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('ID'),
          'description' => E::ts('Unique FormProcessorInput ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.id',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'html' => [
            'type' => 'Number',
          ],
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'form_processor_id' => [
          'name' => 'form_processor_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Form Processor ID'),
          'description' => E::ts('FK to Form Processor'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.form_processor_id',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'FKClassName' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'add' => NULL,
        ],
        'weight' => [
          'name' => 'weight',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Weight'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.weight',
          'default' => '0',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'add' => NULL,
        ],
        'include_formatted_params' => [
          'name' => 'include_formatted_params',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => E::ts('Include in formatted params'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.include_formatted_params',
          'default' => '1',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'add' => NULL,
        ],
        'title' => [
          'name' => 'title',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Title'),
          'required' => FALSE,
          'maxlength' => 128,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.title',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'add' => NULL,
        ],
        'name' => [
          'name' => 'name',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Name'),
          'required' => TRUE,
          'maxlength' => 80,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.name',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'add' => NULL,
        ],
        'type' => [
          'name' => 'type',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Type'),
          'required' => TRUE,
          'maxlength' => 80,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.type',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'add' => NULL,
        ],
        'is_required' => [
          'name' => 'is_required',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => E::ts('Is required'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.is_required',
          'default' => '0',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'add' => NULL,
        ],
        'default_value' => [
          'name' => 'default_value',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Default Value'),
          'required' => FALSE,
          'maxlength' => 256,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.default_value',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'add' => NULL,
        ],
        'configuration' => [
          'name' => 'configuration',
          'type' => CRM_Utils_Type::T_LONGTEXT,
          'title' => E::ts('Configuration'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.configuration',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'serialize' => self::SERIALIZE_JSON,
          'add' => NULL,
        ],
        'parameter_mapping' => [
          'name' => 'parameter_mapping',
          'type' => CRM_Utils_Type::T_LONGTEXT,
          'title' => E::ts('Parameter Mapping'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.parameter_mapping',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'serialize' => self::SERIALIZE_JSON,
          'add' => NULL,
        ],
        'default_data_parameter_mapping' => [
          'name' => 'default_data_parameter_mapping',
          'type' => CRM_Utils_Type::T_LONGTEXT,
          'title' => E::ts('Default Data Parameter Mapping'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_default_data_input.default_data_parameter_mapping',
          'table_name' => 'civicrm_form_processor_default_data_input',
          'entity' => 'FormProcessorDefaultDataInput',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorDefaultDataInput',
          'localizable' => 0,
          'serialize' => self::SERIALIZE_JSON,
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'form_processor_default_data_input', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'form_processor_default_data_input', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [
      'name_id_UNIQUE' => [
        'name' => 'name_id_UNIQUE',
        'field' => [
          0 => 'form_processor_id',
          1 => 'name',
        ],
        'localizable' => FALSE,
        'unique' => TRUE,
        'sig' => 'civicrm_form_processor_default_data_input::1::form_processor_id::name',
      ],
    ];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
