<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from form-processor/xml/schema/CRM/FormProcessor/FormProcessorInstance.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:63161c6d22a74d0670bad07f3fed6551)
 */
use CRM_FormProcessor_ExtensionUtil as E;

/**
 * Database access object for the FormProcessorInstance entity.
 */
class CRM_FormProcessor_DAO_FormProcessorInstance extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_form_processor_instance';

  /**
   * Field to show when displaying a record.
   *
   * @var string
   */
  public static $_labelField = 'title';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * @var string
   *   (SQL type: varchar(80))
   *   Note that values will be retrieved from the database as a string.
   */
  public $title;

  /**
   * @var string
   *   (SQL type: varchar(128))
   *   Note that values will be retrieved from the database as a string.
   */
  public $name;

  /**
   * @var bool|string
   *   (SQL type: tinyint)
   *   Note that values will be retrieved from the database as a string.
   */
  public $is_active;

  /**
   * @var string
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $description;

  /**
   * @var string
   *   (SQL type: varchar(88))
   *   Note that values will be retrieved from the database as a string.
   */
  public $output_handler;

  /**
   * @var string
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $output_handler_configuration;

  /**
   * @var bool|string
   *   (SQL type: tinyint)
   *   Note that values will be retrieved from the database as a string.
   */
  public $enable_default_data;

  /**
   * @var string
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $default_data_output_configuration;

  /**
   * @var string
   *   (SQL type: text)
   *   Note that values will be retrieved from the database as a string.
   */
  public $calculation_output_configuration;

  /**
   * @var string
   *   (SQL type: date)
   *   Note that values will be retrieved from the database as a string.
   */
  public $created_date;

  /**
   * FK to Contact
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $created_user_id;

  /**
   * @var string
   *   (SQL type: date)
   *   Note that values will be retrieved from the database as a string.
   */
  public $modified_date;

  /**
   * FK to Contact
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $modified_user_id;

  /**
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $permission;

  /**
   * @var int|string
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $status;

  /**
   * @var string
   *   (SQL type: varchar(255))
   *   Note that values will be retrieved from the database as a string.
   */
  public $source_file;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_form_processor_instance';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('Form Processor Instances') : E::ts('Form Processor Instance');
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.id',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'html' => [
            'type' => 'Number',
          ],
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'title' => [
          'name' => 'title',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Title'),
          'required' => TRUE,
          'maxlength' => 80,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.title',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'html' => [
            'type' => 'Text',
          ],
          'add' => NULL,
        ],
        'name' => [
          'name' => 'name',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Name'),
          'required' => FALSE,
          'maxlength' => 128,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.name',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'html' => [
            'type' => 'Text',
          ],
          'add' => NULL,
        ],
        'is_active' => [
          'name' => 'is_active',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => E::ts('Is active'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.is_active',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'html' => [
            'type' => 'CheckBox',
            'label' => E::ts("Enabled"),
          ],
          'add' => NULL,
        ],
        'description' => [
          'name' => 'description',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Description'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.description',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'html' => [
            'type' => 'TextArea',
          ],
          'add' => NULL,
        ],
        'output_handler' => [
          'name' => 'output_handler',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Output Handler'),
          'required' => TRUE,
          'maxlength' => 88,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.output_handler',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'add' => NULL,
        ],
        'output_handler_configuration' => [
          'name' => 'output_handler_configuration',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Output Handler Configuration'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.output_handler_configuration',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'add' => NULL,
        ],
        'enable_default_data' => [
          'name' => 'enable_default_data',
          'type' => CRM_Utils_Type::T_BOOLEAN,
          'title' => E::ts('Enable Default Data Retrieval'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.enable_default_data',
          'default' => '0',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'add' => NULL,
        ],
        'default_data_output_configuration' => [
          'name' => 'default_data_output_configuration',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Default Data Output Configuration'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.default_data_output_configuration',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'add' => NULL,
        ],
        'calculation_output_configuration' => [
          'name' => 'calculation_output_configuration',
          'type' => CRM_Utils_Type::T_TEXT,
          'title' => E::ts('Calculation Output Configuration'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.calculation_output_configuration',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'add' => NULL,
        ],
        'created_date' => [
          'name' => 'created_date',
          'type' => CRM_Utils_Type::T_DATE,
          'title' => E::ts('Created Date'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.created_date',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'add' => NULL,
        ],
        'created_user_id' => [
          'name' => 'created_user_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('created_user_id By'),
          'description' => E::ts('FK to Contact'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.created_user_id',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'FKClassName' => 'CRM_Contact_DAO_Contact',
          'add' => NULL,
        ],
        'modified_date' => [
          'name' => 'modified_date',
          'type' => CRM_Utils_Type::T_DATE,
          'title' => E::ts('Modified Date'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.modified_date',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'add' => NULL,
        ],
        'modified_user_id' => [
          'name' => 'modified_user_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('modified_user_id By'),
          'description' => E::ts('FK to Contact'),
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.modified_user_id',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'FKClassName' => 'CRM_Contact_DAO_Contact',
          'add' => NULL,
        ],
        'permission' => [
          'name' => 'permission',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Permission'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.permission',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'add' => NULL,
        ],
        'status' => [
          'name' => 'status',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Status'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.status',
          'default' => '1',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'pseudoconstant' => [
            'callback' => 'CRM_FormProcessor_Status::statusLabels',
          ],
          'add' => NULL,
        ],
        'source_file' => [
          'name' => 'source_file',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Source File'),
          'required' => FALSE,
          'maxlength' => 255,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_instance.source_file',
          'table_name' => 'civicrm_form_processor_instance',
          'entity' => 'FormProcessorInstance',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'localizable' => 0,
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'form_processor_instance', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'form_processor_instance', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
