<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from form-processor/xml/schema/CRM/FormProcessor/FormProcessorValidateValidator.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:49ee35b0f81cf71c0ef8a411f6f2f581)
 */
use CRM_FormProcessor_ExtensionUtil as E;

/**
 * Database access object for the FormProcessorValidateValidator entity.
 */
class CRM_FormProcessor_DAO_FormProcessorValidateValidator extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_form_processor_validate_validator';

  /**
   * Field to show when displaying a record.
   *
   * @var string
   */
  public static $_labelField = 'title';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * Unique FormProcessorInput ID
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * FK to Form Processor
   *
   * @var int|string
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $form_processor_id;

  /**
   * @var int|string
   *   (SQL type: int)
   *   Note that values will be retrieved from the database as a string.
   */
  public $weight;

  /**
   * @var string
   *   (SQL type: varchar(128))
   *   Note that values will be retrieved from the database as a string.
   */
  public $title;

  /**
   * @var string
   *   (SQL type: varchar(80))
   *   Note that values will be retrieved from the database as a string.
   */
  public $name;

  /**
   * @var string
   *   (SQL type: varchar(80))
   *   Note that values will be retrieved from the database as a string.
   */
  public $type;

  /**
   * @var string
   *   (SQL type: longtext)
   *   Note that values will be retrieved from the database as a string.
   */
  public $configuration;

  /**
   * @var string
   *   (SQL type: longtext)
   *   Note that values will be retrieved from the database as a string.
   */
  public $mapping;

  /**
   * @var string
   *   (SQL type: longtext)
   *   Note that values will be retrieved from the database as a string.
   */
  public $inputs;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_form_processor_validate_validator';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('Form Processor Validate Validators') : E::ts('Form Processor Validate Validator');
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('ID'),
          'description' => E::ts('Unique FormProcessorInput ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validate_validator.id',
          'table_name' => 'civicrm_form_processor_validate_validator',
          'entity' => 'FormProcessorValidateValidator',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidateValidator',
          'localizable' => 0,
          'html' => [
            'type' => 'Number',
          ],
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'form_processor_id' => [
          'name' => 'form_processor_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Form Processor ID'),
          'description' => E::ts('FK to Form Processor'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validate_validator.form_processor_id',
          'table_name' => 'civicrm_form_processor_validate_validator',
          'entity' => 'FormProcessorValidateValidator',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidateValidator',
          'localizable' => 0,
          'FKClassName' => 'CRM_FormProcessor_DAO_FormProcessorInstance',
          'add' => NULL,
        ],
        'weight' => [
          'name' => 'weight',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Weight'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validate_validator.weight',
          'default' => '0',
          'table_name' => 'civicrm_form_processor_validate_validator',
          'entity' => 'FormProcessorValidateValidator',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidateValidator',
          'localizable' => 0,
          'add' => NULL,
        ],
        'title' => [
          'name' => 'title',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Title'),
          'required' => TRUE,
          'maxlength' => 128,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validate_validator.title',
          'table_name' => 'civicrm_form_processor_validate_validator',
          'entity' => 'FormProcessorValidateValidator',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidateValidator',
          'localizable' => 0,
          'add' => NULL,
        ],
        'name' => [
          'name' => 'name',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Name'),
          'required' => TRUE,
          'maxlength' => 80,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validate_validator.name',
          'table_name' => 'civicrm_form_processor_validate_validator',
          'entity' => 'FormProcessorValidateValidator',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidateValidator',
          'localizable' => 0,
          'add' => NULL,
        ],
        'type' => [
          'name' => 'type',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Type'),
          'required' => TRUE,
          'maxlength' => 80,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validate_validator.type',
          'table_name' => 'civicrm_form_processor_validate_validator',
          'entity' => 'FormProcessorValidateValidator',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidateValidator',
          'localizable' => 0,
          'add' => NULL,
        ],
        'configuration' => [
          'name' => 'configuration',
          'type' => CRM_Utils_Type::T_LONGTEXT,
          'title' => E::ts('Configuration'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validate_validator.configuration',
          'table_name' => 'civicrm_form_processor_validate_validator',
          'entity' => 'FormProcessorValidateValidator',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidateValidator',
          'localizable' => 0,
          'serialize' => self::SERIALIZE_JSON,
          'add' => NULL,
        ],
        'mapping' => [
          'name' => 'mapping',
          'type' => CRM_Utils_Type::T_LONGTEXT,
          'title' => E::ts('Mapping'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validate_validator.mapping',
          'table_name' => 'civicrm_form_processor_validate_validator',
          'entity' => 'FormProcessorValidateValidator',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidateValidator',
          'localizable' => 0,
          'serialize' => self::SERIALIZE_JSON,
          'add' => NULL,
        ],
        'inputs' => [
          'name' => 'inputs',
          'type' => CRM_Utils_Type::T_LONGTEXT,
          'title' => E::ts('Inputs'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validate_validator.inputs',
          'table_name' => 'civicrm_form_processor_validate_validator',
          'entity' => 'FormProcessorValidateValidator',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidateValidator',
          'localizable' => 0,
          'serialize' => self::SERIALIZE_JSON,
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'form_processor_validate_validator', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'form_processor_validate_validator', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
