<?php

/**
 * @package CRM
 * @copyright CiviCRM LLC https://civicrm.org/licensing
 *
 * Generated from form-processor/xml/schema/CRM/FormProcessor/FormProcessorValidation.xml
 * DO NOT EDIT.  Generated by CRM_Core_CodeGen
 * (GenCodeChecksum:a3f6b24b93b7e6c98d5bf8b31cf79e2a)
 */
use CRM_FormProcessor_ExtensionUtil as E;

/**
 * Database access object for the FormProcessorValidation entity.
 */
class CRM_FormProcessor_DAO_FormProcessorValidation extends CRM_Core_DAO {
  const EXT = E::LONG_NAME;
  const TABLE_ADDED = '';

  /**
   * Static instance to hold the table name.
   *
   * @var string
   */
  public static $_tableName = 'civicrm_form_processor_validation';

  /**
   * Should CiviCRM log any modifications to this table in the civicrm_log table.
   *
   * @var bool
   */
  public static $_log = TRUE;

  /**
   * Unique FormProcessorValidation ID
   *
   * @var int|string|null
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $id;

  /**
   * @var string
   *   (SQL type: varchar(256))
   *   Note that values will be retrieved from the database as a string.
   */
  public $entity;

  /**
   * @var int|string
   *   (SQL type: int unsigned)
   *   Note that values will be retrieved from the database as a string.
   */
  public $entity_id;

  /**
   * @var string
   *   (SQL type: varchar(80))
   *   Note that values will be retrieved from the database as a string.
   */
  public $validator;

  /**
   * @var string
   *   (SQL type: longtext)
   *   Note that values will be retrieved from the database as a string.
   */
  public $configuration;

  /**
   * Class constructor.
   */
  public function __construct() {
    $this->__table = 'civicrm_form_processor_validation';
    parent::__construct();
  }

  /**
   * Returns localized title of this entity.
   *
   * @param bool $plural
   *   Whether to return the plural version of the title.
   */
  public static function getEntityTitle($plural = FALSE) {
    return $plural ? E::ts('Form Processor Validations') : E::ts('Form Processor Validation');
  }

  /**
   * Returns all the column names of this table
   *
   * @return array
   */
  public static function &fields() {
    if (!isset(Civi::$statics[__CLASS__]['fields'])) {
      Civi::$statics[__CLASS__]['fields'] = [
        'id' => [
          'name' => 'id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('ID'),
          'description' => E::ts('Unique FormProcessorValidation ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validation.id',
          'table_name' => 'civicrm_form_processor_validation',
          'entity' => 'FormProcessorValidation',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidation',
          'localizable' => 0,
          'html' => [
            'type' => 'Number',
          ],
          'readonly' => TRUE,
          'add' => NULL,
        ],
        'entity' => [
          'name' => 'entity',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Entity'),
          'required' => FALSE,
          'maxlength' => 256,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validation.entity',
          'table_name' => 'civicrm_form_processor_validation',
          'entity' => 'FormProcessorValidation',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidation',
          'localizable' => 0,
          'add' => NULL,
        ],
        'entity_id' => [
          'name' => 'entity_id',
          'type' => CRM_Utils_Type::T_INT,
          'title' => E::ts('Entity ID'),
          'required' => TRUE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validation.entity_id',
          'table_name' => 'civicrm_form_processor_validation',
          'entity' => 'FormProcessorValidation',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidation',
          'localizable' => 0,
          'DFKEntityColumn' => 'entity',
          'FKColumnName' => 'id',
          'html' => [
            'type' => 'Number',
          ],
          'add' => NULL,
        ],
        'validator' => [
          'name' => 'validator',
          'type' => CRM_Utils_Type::T_STRING,
          'title' => E::ts('Validator'),
          'required' => TRUE,
          'maxlength' => 80,
          'size' => CRM_Utils_Type::HUGE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validation.validator',
          'table_name' => 'civicrm_form_processor_validation',
          'entity' => 'FormProcessorValidation',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidation',
          'localizable' => 0,
          'add' => NULL,
        ],
        'configuration' => [
          'name' => 'configuration',
          'type' => CRM_Utils_Type::T_LONGTEXT,
          'title' => E::ts('Configuration'),
          'required' => FALSE,
          'usage' => [
            'import' => FALSE,
            'export' => FALSE,
            'duplicate_matching' => FALSE,
            'token' => FALSE,
          ],
          'where' => 'civicrm_form_processor_validation.configuration',
          'table_name' => 'civicrm_form_processor_validation',
          'entity' => 'FormProcessorValidation',
          'bao' => 'CRM_FormProcessor_DAO_FormProcessorValidation',
          'localizable' => 0,
          'serialize' => self::SERIALIZE_JSON,
          'add' => NULL,
        ],
      ];
      CRM_Core_DAO_AllCoreTables::invoke(__CLASS__, 'fields_callback', Civi::$statics[__CLASS__]['fields']);
    }
    return Civi::$statics[__CLASS__]['fields'];
  }

  /**
   * Returns the list of fields that can be imported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &import($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getImports(__CLASS__, 'form_processor_validation', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of fields that can be exported
   *
   * @param bool $prefix
   *
   * @return array
   */
  public static function &export($prefix = FALSE) {
    $r = CRM_Core_DAO_AllCoreTables::getExports(__CLASS__, 'form_processor_validation', $prefix, []);
    return $r;
  }

  /**
   * Returns the list of indices
   *
   * @param bool $localize
   *
   * @return array
   */
  public static function indices($localize = TRUE) {
    $indices = [];
    return ($localize && !empty($indices)) ? CRM_Core_DAO_AllCoreTables::multilingualize(__CLASS__, $indices) : $indices;
  }

}
